#
#!/bin/bash
#
# Uninstall the AMD SB700/SB8x0/SB9x0/Hudson2/3 
# Driver and Kernel Packages.
#

if [ -n "$EUID" -a "$EUID" != "0" ]; then
	echo This script may only be run by the root user. 1>&2
	exit 1
fi

. ./scripts/functions

set -a
[ -f scripts/defaults ] && . scripts/defaults
set +a

# Verify the supported kernel version
verify_kernel_version
if [ $? = 1 ]; then
	exit 1
fi

# Get the chipset: sb700/sb8x0/sb9x0/Hudson-2/3
get_chipset
if [ -z $CHIPSET ]; then
	echo "ERROR:Unknown chipset!"
	exit 1
fi

#parse_packages

uninstall

